org.apache.poi.poifs.filesystem

## Class DocumentOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - org.apache.poi.poifs.filesystem.DocumentOutputStream

- All Implemented Interfaces:
    java.io.Closeable, java.io.Flushable, java.lang.AutoCloseable

      public final class DocumentOutputStream
      extends java.io.OutputStream

  This class provides methods to write a DocumentEntry managed by a `POIFSFileSystem` instance.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DocumentOutputStream(DirectoryEntry parent, java.lang.String name)` Create an OutputStream to create the specified new Entry
    `DocumentOutputStream(DocumentEntry document)` Create an OutputStream from the specified DocumentEntry.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()`
    `long` | `size()`
    `void` | `write(byte[] b, int off, int len)`
    `void` | `write(int b)`

    - ### Methods inherited from class java.io.OutputStream

      `flush, write`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DocumentOutputStream

          public DocumentOutputStream(DocumentEntry document)
                               throws java.io.IOException

      Create an OutputStream from the specified DocumentEntry. The specified entry will be emptied.
      Parameters:
        `document` - the DocumentEntry to be written
      Throws:
        `java.io.IOException`

    - #### DocumentOutputStream

          public DocumentOutputStream(DirectoryEntry parent,
                                      java.lang.String name)
                               throws java.io.IOException

      Create an OutputStream to create the specified new Entry
      Parameters:
        `parent` - Where to create the Entry
        `name` - Name of the new entry
      Throws:
        `java.io.IOException`

  - ### Method Detail

    - #### write

          public void write(int b)
                     throws java.io.IOException

      Specified by:
        `write` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### write

          public void write(byte[] b,
                            int off,
                            int len)
                     throws java.io.IOException

      Overrides:
        `write` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### close

          public void close()
                     throws java.io.IOException

      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Overrides:
        `close` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### size

          public long size()

      Returns:
        the amount of written bytes

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.